(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/badge', ['exports', '@angular/common', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.badge = {}), global.ng.common, global.ng.core));
}(this, (function (exports, common, core) { 'use strict';

    var NtBadgeComponent = /** @class */ (function () {
        function NtBadgeComponent(platformId, _elementRef, _renderer) {
            this.platformId = platformId;
            this._elementRef = _elementRef;
            this._renderer = _renderer;
            this._type = 'static';
            this.color = '';
            this.class = '';
        }
        Object.defineProperty(NtBadgeComponent.prototype, "type", {
            get: function () { return this._type; },
            set: function (value) {
                if (value === 'float' || value === 'notify') {
                    this._resetPosition();
                }
                else {
                    this._clearPosition();
                }
                this._type = value;
            },
            enumerable: false,
            configurable: true
        });
        NtBadgeComponent.prototype.ngAfterViewInit = function () {
            this._resetPosition();
        };
        NtBadgeComponent.prototype.ngOnDestroy = function () {
            this._clearPosition();
        };
        NtBadgeComponent.prototype._resetPosition = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                var style = window.getComputedStyle(this._elementRef.nativeElement.parentElement);
                if (style.position !== 'absolute' || style.position !== 'absolute') {
                    this._originalPosition = style.position;
                    this._renderer.setStyle(this._elementRef.nativeElement.parentElement, 'position', 'relative');
                }
            }
        };
        NtBadgeComponent.prototype._clearPosition = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                if (this._originalPosition) {
                    this._renderer.removeStyle(this._elementRef.nativeElement.parentElement, 'position');
                }
            }
        };
        return NtBadgeComponent;
    }());
    NtBadgeComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-badge, [nt-badge]',
                    template: "<ng-content></ng-content>",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        '[class]': '["badge", color, class].join(" ")',
                        '[class.badge-float]': 'type === "float"',
                        '[class.badge-notify]': 'type === "notify"'
                    }
                },] }
    ];
    NtBadgeComponent.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    NtBadgeComponent.propDecorators = {
        color: [{ type: core.Input }],
        class: [{ type: core.Input }],
        type: [{ type: core.Input }]
    };

    var NtBadgeModule = /** @class */ (function () {
        function NtBadgeModule() {
        }
        return NtBadgeModule;
    }());
    NtBadgeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [NtBadgeComponent],
                    exports: [NtBadgeComponent]
                },] }
    ];

    exports.NtBadgeComponent = NtBadgeComponent;
    exports.NtBadgeModule = NtBadgeModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=badge.umd.js.map
