(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/animations'), require('@angular/cdk/coercion'), require('@ng-tangram/components/core')) :
  typeof define === 'function' && define.amd ? define('@ng-tangram/components/callout', ['exports', '@angular/common', '@angular/core', '@angular/animations', '@angular/cdk/coercion', '@ng-tangram/components/core'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.callout = {}), global.ng.common, global.ng.core, global.ng.animations, global.ng.cdk.coercion, global.nt.components.core));
}(this, (function (exports, common, core, animations, coercion, core$1) { 'use strict';

  var NtCalloutComponent = /** @class */ (function () {
      function NtCalloutComponent() {
          this.title = '';
          this.color = 'primary';
          this.size = 'medium';
          this.class = '';
          this._closed = false;
          this.close = new core.EventEmitter();
          this.fadeOut = false;
      }
      Object.defineProperty(NtCalloutComponent.prototype, "closed", {
          get: function () { return this._closed; },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(NtCalloutComponent.prototype, "closable", {
          get: function () { return this._closable; },
          set: function (value) { this._closable = coercion.coerceBooleanProperty(value); },
          enumerable: false,
          configurable: true
      });
      NtCalloutComponent.prototype.onAnimationDone = function (event) {
          if (event.toState) {
              this._closed = true;
          }
      };
      NtCalloutComponent.prototype._close = function () {
          if (!this.fadeOut) {
              this.fadeOut = true;
              this.close.emit();
          }
      };
      return NtCalloutComponent;
  }());
  NtCalloutComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'nt-callout',
                  template: "\n    <h3 *ngIf=\"title\">{{title}}</h3>\n    <ng-content></ng-content>\n    <button *ngIf=\"this.closable\" (click)=\"_close()\" class=\"close-button\" type=\"button\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  ",
                  encapsulation: core.ViewEncapsulation.None,
                  animations: [
                      animations.trigger('fadeOut', [
                          animations.transition('* => true', core$1.fadeOut(.3))
                      ])
                  ],
                  host: {
                      '[class]': '["callout nt-callout", color || "primary", size, class].join(" ")',
                      '[class.closed]': 'closed'
                  }
              },] }
  ];
  NtCalloutComponent.ctorParameters = function () { return []; };
  NtCalloutComponent.propDecorators = {
      title: [{ type: core.Input }],
      color: [{ type: core.Input }],
      size: [{ type: core.Input }],
      class: [{ type: core.Input }],
      closable: [{ type: core.Input }],
      close: [{ type: core.Output }],
      fadeOut: [{ type: core.HostBinding, args: ['@fadeOut',] }],
      onAnimationDone: [{ type: core.HostListener, args: ['@fadeOut.done', ['$event'],] }]
  };

  var NtCalloutModule = /** @class */ (function () {
      function NtCalloutModule() {
      }
      return NtCalloutModule;
  }());
  NtCalloutModule.decorators = [
      { type: core.NgModule, args: [{
                  imports: [common.CommonModule],
                  exports: [NtCalloutComponent],
                  declarations: [NtCalloutComponent],
              },] }
  ];

  exports.NtCalloutComponent = NtCalloutComponent;
  exports.NtCalloutModule = NtCalloutModule;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=callout.umd.js.map
