(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/forms'), require('@angular/animations'), require('@angular/cdk/coercion'), require('@ng-tangram/components/core')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/forms', ['exports', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/forms', '@angular/animations', '@angular/cdk/coercion', '@ng-tangram/components/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.forms = {}), global.ng.common, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.forms, global.ng.animations, global.ng.cdk.coercion, global.nt.components.core));
}(this, (function (exports, common, core, rxjs, operators, forms, animations, coercion, core$1) { 'use strict';

    var NtFormFieldControl = /** @class */ (function () {
        function NtFormFieldControl() {
        }
        NtFormFieldControl.prototype.focus = function () { };
        return NtFormFieldControl;
    }());

    var NtFormLabelWidthDirective = /** @class */ (function () {
        function NtFormLabelWidthDirective() {
            this._widthChange = new rxjs.Subject();
            this._width = 120;
        }
        Object.defineProperty(NtFormLabelWidthDirective.prototype, "width", {
            get: function () { return this._width; },
            set: function (value) {
                this._width = coercion.coerceNumberProperty(value, 120);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormLabelWidthDirective.prototype, "widthChange", {
            get: function () { return this._widthChange.asObservable(); },
            enumerable: false,
            configurable: true
        });
        NtFormLabelWidthDirective.prototype.ngOnChanges = function (changes) {
            var change = changes.width;
            if (change.currentValue !== change.previousValue) {
                this._widthChange.next(change.currentValue);
            }
        };
        NtFormLabelWidthDirective.prototype.ngOnDestroy = function () {
            this._widthChange.complete();
        };
        return NtFormLabelWidthDirective;
    }());
    NtFormLabelWidthDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'form[ntFormLabelWidth]',
                },] }
    ];
    NtFormLabelWidthDirective.propDecorators = {
        width: [{ type: core.Input, args: ['ntFormLabelWidth',] }]
    };

    var NtFormOrientationDirective = /** @class */ (function () {
        function NtFormOrientationDirective() {
            this._orientationChange = new rxjs.Subject();
        }
        Object.defineProperty(NtFormOrientationDirective.prototype, "orientation", {
            get: function () { return this._orientation; },
            set: function (value) {
                this._orientation = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormOrientationDirective.prototype, "orientationChange", {
            get: function () {
                return this._orientationChange.asObservable();
            },
            enumerable: false,
            configurable: true
        });
        NtFormOrientationDirective.prototype.ngOnChanges = function (changes) {
            var change = changes.orientation;
            if (change.currentValue !== change.previousValue) {
                this._orientationChange.next(change.currentValue);
            }
        };
        NtFormOrientationDirective.prototype.ngOnDestroy = function () {
            this._orientationChange.complete();
        };
        return NtFormOrientationDirective;
    }());
    NtFormOrientationDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'form[ntFormOrientation]',
                },] }
    ];
    NtFormOrientationDirective.propDecorators = {
        orientation: [{ type: core.Input, args: ['ntFormOrientation',] }]
    };

    var NtFormFieldComponent = /** @class */ (function () {
        function NtFormFieldComponent(_ngZone, _changeDetectorRef, parentForm, parentFormGroup, _formLabelWidth, _formOrientation) {
            var _this = this;
            this._ngZone = _ngZone;
            this._changeDetectorRef = _changeDetectorRef;
            this._formLabelWidth = _formLabelWidth;
            this._formOrientation = _formOrientation;
            this._destroy = new rxjs.Subject();
            this._markVisible = true;
            this._isDefaultWidthValue = true;
            this._ngForm = null;
            this._labelStyles = {};
            this._groupStyles = {};
            this._invalid = false;
            this._labelVisible = true;
            this._labelWidth = 120;
            this.statusChanges = rxjs.defer(function () {
                if (_this.control && _this.ngControl) {
                    return _this.ngControl.statusChanges ? _this.ngControl.statusChanges : rxjs.of(null);
                }
                return _this._ngZone.onStable
                    .asObservable()
                    .pipe(operators.take(1), operators.switchMap(function () { return _this.statusChanges; }));
            });
            this._ngForm = parentForm || parentFormGroup;
            if (this._formLabelWidth) {
                this._subscribeContainerWidthChange();
            }
            if (this._formOrientation) {
                this._subscribeContainerOrientationChange();
            }
            this.statusChanges
                .pipe(operators.takeUntil(this._destroy))
                .subscribe(function () { return _this._validate(); });
        }
        Object.defineProperty(NtFormFieldComponent.prototype, "labelVisible", {
            get: function () { return this._labelVisible; },
            set: function (value) {
                this._labelVisible = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "labelWidth", {
            get: function () { return this._labelWidth; },
            set: function (value) {
                var coercedValue = coercion.coerceNumberProperty(value, 0);
                if (coercedValue > 0) {
                    this._isDefaultWidthValue = false;
                    this._labelWidth = coercedValue;
                }
                else {
                    this._isDefaultWidthValue = true;
                    this._labelWidth = 120;
                }
                this._setHorizontalStyles();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "orientation", {
            get: function () { return this._orientation; },
            set: function (value) {
                this._orientation = value;
                this._setHorizontalStyles();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "markVisible", {
            get: function () { return this._markVisible; },
            set: function (value) {
                this._markVisible = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "required", {
            get: function () {
                if (this.ngControl &&
                    this.ngControl.control &&
                    this.ngControl.control.validator) {
                    var control = new forms.FormControl();
                    var validateResult = this.ngControl.control.validator(control);
                    return validateResult && validateResult.hasOwnProperty('required');
                }
                if (this.control) {
                    return !!this.control.required;
                }
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "errors", {
            get: function () {
                return this.control.ngControl ? this.control.ngControl.errors : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "ngControl", {
            get: function () { return this.control ? this.control.ngControl : null; },
            enumerable: false,
            configurable: true
        });
        NtFormFieldComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this._ngForm && this.ngControl) {
                this._ngForm.ngSubmit
                    .pipe(operators.takeUntil(this._destroy))
                    .subscribe(function () { return _this._validate(); });
            }
        };
        NtFormFieldComponent.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
        };
        NtFormFieldComponent.prototype._clearValidateMessage = function () {
            this._invalid = false;
        };
        NtFormFieldComponent.prototype.isHorizontal = function () {
            return this.orientation === 'horizontal';
        };
        NtFormFieldComponent.prototype.isVertical = function () {
            return this.orientation === 'vertical';
        };
        NtFormFieldComponent.prototype._validate = function () {
            if (this.ngControl) {
                this._invalid = !!this.ngControl.invalid;
                this._changeDetectorRef.markForCheck();
            }
        };
        NtFormFieldComponent.prototype._subscribeContainerWidthChange = function () {
            var _this = this;
            this._formLabelWidth.widthChange
                .pipe(operators.filter(function () { return _this._isDefaultWidthValue; }), operators.takeUntil(this._destroy))
                .subscribe(function (width) {
                _this._labelWidth = width;
                _this._setHorizontalStyles();
            });
        };
        NtFormFieldComponent.prototype._subscribeContainerOrientationChange = function () {
            var _this = this;
            this._formOrientation.orientationChange
                .pipe(operators.filter(function () { return !_this._orientation; }), operators.takeUntil(this._destroy))
                .subscribe(function (orientation) {
                _this._orientation = orientation;
                _this._setHorizontalStyles();
            });
        };
        NtFormFieldComponent.prototype._setHorizontalStyles = function () {
            if (this.labelWidth > 0 && this.isHorizontal()) {
                this._labelStyles['width.px'] = this.labelWidth;
                this._groupStyles['margin-left.px'] = this.labelWidth;
            }
            else {
                delete this._labelStyles['width.px'];
                delete this._groupStyles['margin-left.px'];
            }
        };
        return NtFormFieldComponent;
    }());
    NtFormFieldComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-form-field',
                    template: "\n    <label class=\"nt-form-label\"\n      *ngIf=\"labelVisible\"\n      [ngStyle]=\"_labelStyles\"\n      [class.required]=\"markVisible && required\">\n      {{ label }}\n    </label>\n    <div class=\"nt-form-group\" [ngStyle]=\"_groupStyles\">\n      <ng-content></ng-content>\n      <span class=\"form-error is-visible\" *ngIf=\"_invalid && errors\" [@fade]=\"_invalid\">\n        {{ errors | formError:label:messages }}\n      </span>\n    </div>\n  ",
                    animations: [
                        animations.trigger('fade', [
                            animations.transition('* => false', core$1.fadeOut(.15)),
                            animations.transition('* => true', core$1.fadeIn(.15))
                        ])
                    ],
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-form-field',
                        '[class.nt-form-error]': '_invalid',
                        '[class.nt-form-horizontal]': 'isHorizontal()'
                    }
                },] }
    ];
    NtFormFieldComponent.ctorParameters = function () { return [
        { type: core.NgZone },
        { type: core.ChangeDetectorRef },
        { type: forms.NgForm, decorators: [{ type: core.Optional }] },
        { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] },
        { type: NtFormLabelWidthDirective, decorators: [{ type: core.Optional }] },
        { type: NtFormOrientationDirective, decorators: [{ type: core.Optional }] }
    ]; };
    NtFormFieldComponent.propDecorators = {
        label: [{ type: core.Input }],
        labelVisible: [{ type: core.Input }],
        labelWidth: [{ type: core.Input }],
        messages: [{ type: core.Input }],
        orientation: [{ type: core.Input }],
        markVisible: [{ type: core.Input }],
        control: [{ type: core.ContentChild, args: [NtFormFieldControl,] }]
    };

    var NtFormAutofocusDirective = /** @class */ (function () {
        function NtFormAutofocusDirective(form, formGroup) {
            this._destory = new rxjs.Subject();
            this.formContainer = form || formGroup;
        }
        NtFormAutofocusDirective.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this.formContainer) {
                this.formContainer.ngSubmit
                    .pipe(operators.takeUntil(this._destory))
                    .subscribe(function () {
                    var field = _this.fields.find(function (field) { return !!field.ngControl && !!field.ngControl.invalid; });
                    if (field && field.control) {
                        field.control.focus();
                    }
                });
            }
        };
        NtFormAutofocusDirective.prototype.ngOnDestroy = function () {
            this._destory.next();
            this._destory.complete();
        };
        return NtFormAutofocusDirective;
    }());
    NtFormAutofocusDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'form[ntFormAutofocus]'
                },] }
    ];
    NtFormAutofocusDirective.ctorParameters = function () { return [
        { type: forms.NgForm, decorators: [{ type: core.Optional }] },
        { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] }
    ]; };
    NtFormAutofocusDirective.propDecorators = {
        fields: [{ type: core.ContentChildren, args: [NtFormFieldComponent, { descendants: true },] }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var DEFAULT_TEMPLATES = {
        required: "请填写{0}",
        email: "{0}不是邮箱格式",
        min: "{0}必须输入大于{1}的数字",
        max: "{0}必须输入小于{1}的数字",
        pattern: "{0}不是合法的数据",
        maxlength: "{0}长度为最大{1}",
        minlength: "{0}长度为最小{1}",
        selection: '请选择{0}',
        upload: '请上传{0}',
        equalTo: '两次输入不一致',
        ltTo: '{0}的最小值应小于{1}',
        ltDateTo: '{0}应早于{1}',
        gtDateTo: '{0}应晚于{1}',
        unequalTo: '{0}必须和{1}不相同',
        intervalTo: '请输入正确区间值',
        notUnique: '{0}已存在',
        incorrect: '请输入正确{0}',
    };
    var NtFormValidationTransformer = /** @class */ (function () {
        function NtFormValidationTransformer() {
        }
        NtFormValidationTransformer.prototype.transform = function (errors, label, messages) {
            if (!errors) {
                return '';
            }
            var templates = Object.assign(Object.assign({}, DEFAULT_TEMPLATES), messages);
            if (errors.hasOwnProperty('required')) {
                if (errors.hasOwnProperty('selection')) {
                    return this._format(templates['selection'], label);
                }
                else if (errors.hasOwnProperty('upload')) {
                    return this._format(templates['upload'], label);
                }
                return this._format(templates['required'], label);
            }
            else if (errors.hasOwnProperty('email')) {
                return this._format(templates['email'], label);
            }
            else if (errors.hasOwnProperty('min')) {
                return this._format(templates['min'], label, errors.min.min);
            }
            else if (errors.hasOwnProperty('max')) {
                return this._format(templates['max'], label, errors.max.max);
            }
            else if (errors.hasOwnProperty('minlength')) {
                return this._format(templates['minlength'], label, errors.minlength.requiredLength);
            }
            else if (errors.hasOwnProperty('maxlength')) {
                return this._format(templates['maxlength'], label, errors.maxlength.requiredLength);
            }
            else if (errors.hasOwnProperty('pattern')) {
                return this._format(templates['pattern'], label);
            }
            else if (errors.hasOwnProperty('equalTo')) {
                return this._format(templates['equalTo'], label, errors.equalLabel);
            }
            else if (errors.hasOwnProperty('ltTo')) {
                return this._format(templates['ltTo'], label, errors.ltLabel);
            }
            else if (errors.hasOwnProperty('ltDateTo')) {
                return this._format(templates['ltDateTo'], label, errors.ltLabel);
            }
            else if (errors.hasOwnProperty('gtDateTo')) {
                return this._format(templates['gtDateTo'], label, errors.gtLabel);
            }
            else if (errors.hasOwnProperty('unequalTo')) {
                return this._format(templates['unequalTo'], label, errors.unequalLabel);
            }
            else if (errors.hasOwnProperty('intervalTo')) {
                return this._format(templates['intervalTo']);
            }
            else if (errors.hasOwnProperty('notUnique')) {
                return this._format(templates['notUnique'], label);
            }
            else if (errors.hasOwnProperty('incorrect')) {
                return this._format(templates['incorrect'], label);
            }
            else {
                return '';
            }
        };
        NtFormValidationTransformer.prototype._format = function (template) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return template.replace(/\{(\d+)\}/g, function (match, number) {
                return typeof args[number] !== 'undefined' ? args[number] : match;
            });
        };
        return NtFormValidationTransformer;
    }());
    NtFormValidationTransformer.decorators = [
        { type: core.Injectable }
    ];
    var NT_VALIDATION_TRANSFOMER = new core.InjectionToken('nt-validation-transformer');

    var NtFormErrorPipe = /** @class */ (function () {
        function NtFormErrorPipe(_transformer) {
            this._transformer = _transformer;
        }
        NtFormErrorPipe.prototype.transform = function (value) {
            var _a;
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return (_a = this._transformer).transform.apply(_a, __spread([value], args));
        };
        return NtFormErrorPipe;
    }());
    NtFormErrorPipe.decorators = [
        { type: core.Pipe, args: [{ name: 'formError' },] }
    ];
    NtFormErrorPipe.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [NT_VALIDATION_TRANSFOMER,] }] }
    ]; };

    var NtFormsModule = /** @class */ (function () {
        function NtFormsModule() {
        }
        NtFormsModule.forRoot = function (transformer) {
            return {
                ngModule: NtFormsModule,
                providers: [
                    { provide: NT_VALIDATION_TRANSFOMER, useClass: transformer || NtFormValidationTransformer }
                ]
            };
        };
        return NtFormsModule;
    }());
    NtFormsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [
                        NtFormFieldComponent,
                        NtFormAutofocusDirective,
                        NtFormLabelWidthDirective,
                        NtFormOrientationDirective,
                        NtFormErrorPipe
                    ],
                    declarations: [
                        NtFormFieldComponent,
                        NtFormAutofocusDirective,
                        NtFormLabelWidthDirective,
                        NtFormOrientationDirective,
                        NtFormErrorPipe
                    ]
                },] }
    ];

    function requiredSelection(control) {
        var errors = forms.Validators.required(control);
        return errors && errors.required ? { required: true, selection: true } : null;
    }
    function requiredUpload(control) {
        var errors = forms.Validators.required(control);
        return errors && errors.required ? { required: true, upload: true } : null;
    }
    function equalTo(equalControl, equalLabel) {
        var subscribe;
        return function (control) {
            if (!subscribe) {
                subscribe = equalControl.valueChanges
                    .pipe(operators.filter(function () { return control.touched; }))
                    .subscribe(function () {
                    control.updateValueAndValidity();
                });
            }
            var controlValue = control.value;
            return equalControl.value == controlValue ? null : { equalTo: true, equalLabel: equalLabel };
        };
    }
    function unequalTo(equalControl, unequalLabel) {
        var subscribe;
        return function (control) {
            if (!subscribe) {
                subscribe = equalControl.valueChanges
                    .pipe(operators.filter(function () { return control.touched; }))
                    .subscribe(function () {
                    control.updateValueAndValidity();
                });
            }
            var controlValue = control.value;
            return equalControl.value !== controlValue ? null : { unequalTo: true, unequalLabel: unequalLabel };
        };
    }
    function interval(intervalLabel) {
        return function (control) {
            if (control.value) {
                var controlValue = control.value.split(/(\(|\)|\[|\]|,)/g);
                return Number(controlValue[2]) < Number(controlValue[4]) ? null : { intervalTo: true, intervalLabel: intervalLabel };
            }
            return null;
        };
    }
    function ltTo(withControl, ltLabel) {
        var subscribe;
        return function (control) {
            if (!subscribe) {
                subscribe = withControl.valueChanges
                    .pipe(operators.filter(function () { return control.touched; }))
                    .subscribe(function () {
                    control.updateValueAndValidity();
                });
            }
            var controlValue = control.value;
            if (withControl.value) {
                return Number(controlValue) < Number(withControl.value) ? null : { ltTo: true, ltLabel: ltLabel };
            }
            return null;
        };
    }
    function ltDateTo(withControl, ltLabel, dateAdapter) {
        var subscribe;
        return function (control) {
            if (!subscribe) {
                subscribe = withControl.valueChanges.subscribe(function () {
                    control.updateValueAndValidity();
                });
            }
            if (withControl.value && control.value) {
                return dateAdapter.compareDate(dateAdapter.deserialize(control.value), dateAdapter.deserialize(withControl.value)) < 0 ? null : { ltDateTo: true, ltLabel: ltLabel };
            }
            return null;
        };
    }
    function gtDateTo(withControl, gtLabel, dateAdapter) {
        var subscribe;
        return function (control) {
            if (!subscribe) {
                subscribe = withControl.valueChanges.subscribe(function () {
                    control.updateValueAndValidity();
                });
            }
            if (withControl.value && control.value) {
                return dateAdapter.compareDate(dateAdapter.deserialize(control.value), dateAdapter.deserialize(withControl.value)) > 0 ? null : { gtDateTo: true, gtLabel: gtLabel };
            }
            return null;
        };
    }

    exports.DEFAULT_TEMPLATES = DEFAULT_TEMPLATES;
    exports.NT_VALIDATION_TRANSFOMER = NT_VALIDATION_TRANSFOMER;
    exports.NtFormAutofocusDirective = NtFormAutofocusDirective;
    exports.NtFormErrorPipe = NtFormErrorPipe;
    exports.NtFormFieldComponent = NtFormFieldComponent;
    exports.NtFormFieldControl = NtFormFieldControl;
    exports.NtFormLabelWidthDirective = NtFormLabelWidthDirective;
    exports.NtFormOrientationDirective = NtFormOrientationDirective;
    exports.NtFormValidationTransformer = NtFormValidationTransformer;
    exports.NtFormsModule = NtFormsModule;
    exports.equalTo = equalTo;
    exports.gtDateTo = gtDateTo;
    exports.interval = interval;
    exports.ltDateTo = ltDateTo;
    exports.ltTo = ltTo;
    exports.requiredSelection = requiredSelection;
    exports.requiredUpload = requiredUpload;
    exports.unequalTo = unequalTo;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=forms.umd.js.map
