(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/pagination', ['exports', '@angular/common', '@angular/core', '@angular/cdk/coercion'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.pagination = {}), global.ng.common, global.ng.core, global.ng.cdk.coercion));
}(this, (function (exports, common, core, coercion) { 'use strict';

    var NtPaginationConfig = /** @class */ (function () {
        function NtPaginationConfig() {
            this.previousLabel = '«';
            this.nextLabel = '»';
            this.itemSize = 2;
            this.pageSize = 10;
        }
        return NtPaginationConfig;
    }());
    var NT_PAGINATION_CONFIG = new core.InjectionToken('nt-pagination-config');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var PAGINATION_ELLIPSIS = '...';
    var NtPaginationComponent = /** @class */ (function () {
        function NtPaginationComponent(_changeDetectorRef, defaultConfig) {
            this._changeDetectorRef = _changeDetectorRef;
            this._totalPage = 1;
            this._pageItems = [1];
            this._options = new NtPaginationConfig();
            this._total = 0;
            this._pageIndex = 1;
            this.pageChange = new core.EventEmitter();
            this._options = Object.assign(Object.assign({}, this._options), defaultConfig || {});
        }
        Object.defineProperty(NtPaginationComponent.prototype, "totalPage", {
            get: function () { return this._totalPage; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "pageItems", {
            get: function () { return this._pageItems; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "options", {
            get: function () { return this._options; },
            set: function (value) {
                if (typeof value === 'object') {
                    this._options = Object.assign({}, this._options, value);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "itemSize", {
            get: function () { return this.options.itemSize; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "pageSize", {
            get: function () { return this.options.pageSize; },
            set: function (value) { this._options.pageSize = coercion.coerceNumberProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "previousLabel", {
            get: function () { return this.options.previousLabel; },
            set: function (value) { this._options.previousLabel = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "nextLabel", {
            get: function () { return this.options.nextLabel; },
            set: function (value) { this._options.nextLabel = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "total", {
            get: function () { return this._total; },
            set: function (value) { this._total = coercion.coerceNumberProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPaginationComponent.prototype, "pageIndex", {
            get: function () { return this._pageIndex; },
            set: function (value) { this._pageIndex = coercion.coerceNumberProperty(value, 1); },
            enumerable: false,
            configurable: true
        });
        NtPaginationComponent.prototype.ngOnInit = function () {
            this._calcPageItems();
        };
        NtPaginationComponent.prototype.ngOnChanges = function (changes) {
            var change = changes.total || changes.pageIndex;
            if (change && !change.firstChange) {
                this._calcPageItems();
            }
        };
        NtPaginationComponent.prototype._pageChange = function (index) {
            this.pageIndex = coercion.coerceNumberProperty(index, 1);
            this.pageChange.emit(this.pageIndex);
        };
        NtPaginationComponent.prototype._calcPageItems = function () {
            this._totalPage = Math.ceil(this.total / this.pageSize);
            var pageItems = [1];
            if (this.pageIndex > this._totalPage) {
                this._pageIndex = this._totalPage;
            }
            if (this._totalPage > 1) {
                var _a = __read([
                    Math.max(this.pageIndex - this.itemSize, 2),
                    Math.min(this.pageIndex + this.itemSize, this.totalPage - 1)
                ], 2), start = _a[0], end = _a[1];
                if (start - 2 >= 1) {
                    pageItems.push(PAGINATION_ELLIPSIS);
                }
                pageItems = pageItems.concat(Array(end - start + 1).fill(start).map(function (v, i) { return v + i; }));
                if (end + 2 <= this.totalPage) {
                    pageItems.push(PAGINATION_ELLIPSIS);
                }
                if (this.totalPage > 1) {
                    pageItems.push(this.totalPage);
                }
            }
            this._pageItems = pageItems;
        };
        return NtPaginationComponent;
    }());
    NtPaginationComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-pagination',
                    template: "<ul class=\"nt-pagination\">\n  <li class=\"nt-pagination-previous\">\n    <a [class.disabled]=\"pageIndex === 1\" (click)=\"_pageChange(pageIndex - 1)\">{{ previousLabel }}</a>\n  </li>\n\n  <ng-container *ngFor=\"let item of pageItems\">\n    <li *ngIf=\"item === pageIndex\" [class.current]=\"item === pageIndex\">{{ item }}</li>\n    <li *ngIf=\"item !== pageIndex && item !== '...'\"><a (click)=\"_pageChange(item)\">{{ item }}</a></li>\n    <li class=\"ellipsis\" *ngIf=\"item === '...'\">{{item}}</li>\n  </ng-container>\n\n  <li class=\"nt-pagination-next\">\n    <a [class.disabled]=\"pageIndex === totalPage\" (click)=\"_pageChange(pageIndex + 1)\">{{ nextLabel }}</a>\n  </li>\n</ul>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    NtPaginationComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: NtPaginationConfig, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_PAGINATION_CONFIG,] }] }
    ]; };
    NtPaginationComponent.propDecorators = {
        options: [{ type: core.Input }],
        pageSize: [{ type: core.Input }],
        previousLabel: [{ type: core.Input }],
        nextLabel: [{ type: core.Input }],
        total: [{ type: core.Input }],
        pageIndex: [{ type: core.Input }],
        pageChange: [{ type: core.Output }]
    };

    var NtPaginationModule = /** @class */ (function () {
        function NtPaginationModule() {
        }
        NtPaginationModule.withConfig = function (config) {
            return {
                ngModule: NtPaginationModule,
                providers: [
                    { provide: NT_PAGINATION_CONFIG, useValue: config || new NtPaginationConfig() }
                ]
            };
        };
        return NtPaginationModule;
    }());
    NtPaginationModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [NtPaginationComponent],
                    declarations: [NtPaginationComponent]
                },] }
    ];

    exports.NT_PAGINATION_CONFIG = NT_PAGINATION_CONFIG;
    exports.NtPaginationComponent = NtPaginationComponent;
    exports.NtPaginationConfig = NtPaginationConfig;
    exports.NtPaginationModule = NtPaginationModule;
    exports.PAGINATION_ELLIPSIS = PAGINATION_ELLIPSIS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=pagination.umd.js.map
