(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/observers'), require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/overlay'), require('@ng-tangram/components/dropdown'), require('rxjs'), require('@angular/cdk/overlay')) :
  typeof define === 'function' && define.amd ? define('@ng-tangram/components/popover', ['exports', '@angular/cdk/observers', '@angular/common', '@angular/core', '@ng-tangram/components/overlay', '@ng-tangram/components/dropdown', 'rxjs', '@angular/cdk/overlay'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.popover = {}), global.ng.cdk.observers, global.ng.common, global.ng.core, global.nt.components.overlay, global.nt.components.dropdown, global.rxjs, global.ng.cdk.overlay));
}(this, (function (exports, observers, common, core, overlay, dropdown, rxjs, overlay$1) { 'use strict';

  var NT_POPOVER_PARENT_COMPONENT = new core.InjectionToken('nt-popover-parent-component');
  var NtPopoverPaneComponent = /** @class */ (function () {
      function NtPopoverPaneComponent(_contentObserver, _elementRef, _parent) {
          this._contentObserver = _contentObserver;
          this._elementRef = _elementRef;
          this._parent = _parent;
          this._contentChange = new rxjs.Subject();
      }
      Object.defineProperty(NtPopoverPaneComponent.prototype, "contentChanged", {
          get: function () {
              return this._contentChange.asObservable();
          },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(NtPopoverPaneComponent.prototype, "textContent", {
          get: function () {
              return (this._elementRef.nativeElement.textContent || '').trim();
          },
          enumerable: false,
          configurable: true
      });
      NtPopoverPaneComponent.prototype.ngAfterContentInit = function () {
          var _this = this;
          this._contentSubscription = this._contentObserver
              .observe(this._elementRef)
              .subscribe(function () { return _this._checkContentChange(); });
      };
      NtPopoverPaneComponent.prototype.ngOnDestroy = function () {
          if (this._contentSubscription) {
              this._contentSubscription.unsubscribe();
          }
      };
      NtPopoverPaneComponent.prototype._checkContentChange = function () {
          if (this._parent.overlay.opened) {
              this._parent.overlay.forceUpdatePosition();
          }
      };
      return NtPopoverPaneComponent;
  }());
  NtPopoverPaneComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'nt-popover-pane, [nt-popover-pane]',
                  template: "\n    <ng-content></ng-content>\n  ",
                  encapsulation: core.ViewEncapsulation.None
              },] }
  ];
  NtPopoverPaneComponent.ctorParameters = function () { return [
      { type: observers.ContentObserver },
      { type: core.ElementRef },
      { type: undefined, decorators: [{ type: core.Inject, args: [NT_POPOVER_PARENT_COMPONENT,] }] }
  ]; };

  var NtPopoverComponent = /** @class */ (function () {
      function NtPopoverComponent(_elementRef) {
          this._elementRef = _elementRef;
          this._title = '';
          this.position = overlay.NtOverlayPosition.Top;
          this.confirm = new core.EventEmitter();
          this.cancel = new core.EventEmitter();
          this.afterOpen = new core.EventEmitter();
          this.afterClosed = new core.EventEmitter();
          this.beforeOpen = new core.EventEmitter();
          this.beforeClosed = new core.EventEmitter();
          this.positionChange = new core.EventEmitter();
          this.origin = new overlay$1.CdkOverlayOrigin(this._elementRef);
      }
      Object.defineProperty(NtPopoverComponent.prototype, "title", {
          get: function () { return this._title; },
          set: function (value) { this._title = value; },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(NtPopoverComponent.prototype, "template", {
          get: function () { return this._template; },
          set: function (value) { this._template = value; },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(NtPopoverComponent.prototype, "popover", {
          set: function (value) {
              if (value instanceof core.TemplateRef) {
                  this._template = value;
              }
              else {
                  this._title = value;
                  this._template = null;
              }
          },
          enumerable: false,
          configurable: true
      });
      NtPopoverComponent.prototype._afterOpen = function (event) {
          this.afterOpen.next(event);
      };
      NtPopoverComponent.prototype._afterClosed = function (event) {
          this.afterClosed.next(event);
      };
      NtPopoverComponent.prototype._beforeOpen = function (event) {
          this.beforeOpen.next(event);
      };
      NtPopoverComponent.prototype._beforeClosed = function (event) {
          this.beforeClosed.next(event);
      };
      NtPopoverComponent.prototype._positionChange = function (change) {
          this.positionChange.next(change);
      };
      return NtPopoverComponent;
  }());
  NtPopoverComponent.decorators = [
      { type: core.Component, args: [{
                  selector: '[nt-popover]',
                  template: "<ng-content></ng-content>\n<nt-overlay\n  overlayClass=\"nt-popover-overlay\"\n  arrow\n  [origin]=\"origin\"\n  [position]=\"position\"\n  (afterOpen)=\"_afterOpen($event)\"\n  (afterClosed)=\"_afterClosed($event)\"\n  (beforeOpen)=\"_beforeOpen($event)\"\n  (beforeClosed)=\"_beforeClosed($event)\"\n  (positionChange)=\"_positionChange($event)\">\n  <div class=\"nt-popover\">\n    <div class=\"nt-popover-title\" *ngIf=\"template\">\n      <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n    <div class=\"nt-popover-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div>\n    <div class=\"nt-popover-pane\">\n      <ng-content select=\"nt-popover-pane\"></ng-content>\n    </div>\n  </div>\n</nt-overlay>\n",
                  encapsulation: core.ViewEncapsulation.None,
                  host: {
                      '(click)': 'overlay.toggle()'
                  },
                  providers: [
                      { provide: NT_POPOVER_PARENT_COMPONENT, useExisting: NtPopoverComponent }
                  ]
              },] }
  ];
  NtPopoverComponent.ctorParameters = function () { return [
      { type: core.ElementRef }
  ]; };
  NtPopoverComponent.propDecorators = {
      title: [{ type: core.Input }],
      template: [{ type: core.Input }],
      popover: [{ type: core.Input, args: ['nt-popover',] }],
      position: [{ type: core.Input }],
      confirm: [{ type: core.Output }],
      cancel: [{ type: core.Output }],
      afterOpen: [{ type: core.Output }],
      afterClosed: [{ type: core.Output }],
      beforeOpen: [{ type: core.Output }],
      beforeClosed: [{ type: core.Output }],
      positionChange: [{ type: core.Output }],
      overlay: [{ type: core.ViewChild, args: [overlay.NtOverlayComponent, { static: true },] }]
  };

  var NtPopoverModule = /** @class */ (function () {
      function NtPopoverModule() {
      }
      return NtPopoverModule;
  }());
  NtPopoverModule.decorators = [
      { type: core.NgModule, args: [{
                  imports: [common.CommonModule, observers.ObserversModule, overlay.NtOverlayModule, dropdown.NtDropdownModule],
                  exports: [NtPopoverComponent, NtPopoverPaneComponent],
                  declarations: [NtPopoverComponent, NtPopoverPaneComponent]
              },] }
  ];

  exports.NT_POPOVER_PARENT_COMPONENT = NT_POPOVER_PARENT_COMPONENT;
  exports.NtPopoverComponent = NtPopoverComponent;
  exports.NtPopoverModule = NtPopoverModule;
  exports.NtPopoverPaneComponent = NtPopoverPaneComponent;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=popover.umd.js.map
