(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/progress', ['exports', '@angular/core', '@angular/cdk/coercion'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.progress = {}), global.ng.core, global.ng.cdk.coercion));
}(this, (function (exports, core, coercion) { 'use strict';

    var NtProgressCircleComponent = /** @class */ (function () {
        function NtProgressCircleComponent() {
            this._max = 100;
            this._value = 0;
            this._radius = 60;
            this.size = 'medium';
            this.color = '';
            this.class = '';
        }
        Object.defineProperty(NtProgressCircleComponent.prototype, "dasharray", {
            get: function () {
                return this.radius * 2 * Math.PI;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "width", {
            get: function () { return this.radius * 2 + 20; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "height", {
            get: function () { return this.radius * 2 + 20; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "radius", {
            get: function () { return this._radius; },
            set: function (value) { this._radius = coercion.coerceNumberProperty(value, 100); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "max", {
            get: function () { return this._max; },
            set: function (value) { this._max = coercion.coerceNumberProperty(value, 100); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "value", {
            get: function () { return this._value; },
            set: function (value) { this._value = coercion.coerceNumberProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "percent", {
            get: function () {
                var percent = this.value / this.max * 100;
                return percent > 100 ? 100 : percent;
            },
            enumerable: false,
            configurable: true
        });
        return NtProgressCircleComponent;
    }());
    NtProgressCircleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-progress-circle',
                    template: "<div class=\"progress-container\">\n  <svg attr.viewPort=\"0 0 {{width / 2}} {{height / 2}}\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"\n    [attr.width]=\"width\" [attr.height]=\"height\">\n    <circle\n      [attr.r]=\"radius\"\n      [attr.cx]=\"width / 2\"\n      [attr.cy]=\"height / 2\"\n      fill=\"transparent\"\n      [attr.stroke-dasharray]=\"dasharray\"\n      [attr.stroke-dashoffset]=\"0\">\n    </circle>\n\n    <circle\n      class=\"progress-meter-circle\"\n      [attr.r]=\"radius\"\n      [attr.cx]=\"width / 2\"\n      [attr.cy]=\"height / 2\"\n      fill=\"transparent\"\n      [attr.stroke-dasharray]=\"dasharray\"\n      [attr.stroke-dashoffset]=\"dasharray - (dasharray / 100 * percent)\">\n    </circle>\n  </svg>\n  <div class=\"progress-inner\">\n    <ng-content></ng-content>\n  </div>\n</div>\n<!-- <div class=\"nt-progress-circle-inner\"><ng-content></ng-content></div> -->\n",
                    host: {
                        '[class]': '["nt-progress-circle", color, size, class].join(" ")'
                    }
                },] }
    ];
    NtProgressCircleComponent.propDecorators = {
        radius: [{ type: core.Input }],
        max: [{ type: core.Input }],
        value: [{ type: core.Input }],
        size: [{ type: core.Input }],
        color: [{ type: core.Input }],
        class: [{ type: core.Input }]
    };

    var NtProgressComponent = /** @class */ (function () {
        function NtProgressComponent() {
            this._max = 100;
            this._value = 0;
            this.size = 'medium';
            this.color = '';
            this.class = '';
        }
        Object.defineProperty(NtProgressComponent.prototype, "max", {
            get: function () { return this._max; },
            set: function (value) { this._max = coercion.coerceNumberProperty(value, 100); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressComponent.prototype, "value", {
            get: function () { return this._value; },
            set: function (value) { this._value = coercion.coerceNumberProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtProgressComponent.prototype, "percent", {
            get: function () {
                var percent = this.value / this.max * 100;
                return percent > 100 ? 100 : percent;
            },
            enumerable: false,
            configurable: true
        });
        return NtProgressComponent;
    }());
    NtProgressComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-progress',
                    template: "<span class=\"progress-meter\" [style.width.%]=\"percent > 100 ? 100 : percent\">\n  <div class=\"progress-meter-text\"><ng-content></ng-content></div>\n</span>\n",
                    host: {
                        '[class]': '["progress", color, size, class].join(" ")'
                    }
                },] }
    ];
    NtProgressComponent.propDecorators = {
        max: [{ type: core.Input }],
        value: [{ type: core.Input }],
        size: [{ type: core.Input }],
        color: [{ type: core.Input }],
        class: [{ type: core.Input }]
    };

    var NtProgressModule = /** @class */ (function () {
        function NtProgressModule() {
        }
        return NtProgressModule;
    }());
    NtProgressModule.decorators = [
        { type: core.NgModule, args: [{
                    exports: [NtProgressComponent, NtProgressCircleComponent],
                    declarations: [NtProgressComponent, NtProgressCircleComponent]
                },] }
    ];

    exports.NtProgressCircleComponent = NtProgressCircleComponent;
    exports.NtProgressComponent = NtProgressComponent;
    exports.NtProgressModule = NtProgressModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=progress.umd.js.map
