(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/core'), require('@angular/forms'), require('rxjs'), require('rxjs/operators'), require('@ng-tangram/components/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/radio', ['exports', '@angular/cdk/coercion', '@angular/core', '@angular/forms', 'rxjs', 'rxjs/operators', '@ng-tangram/components/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.radio = {}), global.ng.cdk.coercion, global.ng.core, global.ng.forms, global.rxjs, global.rxjs.operators, global.nt.components.forms, global.ng.common));
}(this, (function (exports, coercion, core, forms, rxjs, operators, forms$1, common) { 'use strict';

    var uniqueId = 0;
    var NtRadioChange = /** @class */ (function () {
        function NtRadioChange(source, selected) {
            this.source = source;
            this.selected = selected;
        }
        return NtRadioChange;
    }());
    var NtRadioComponent = /** @class */ (function () {
        function NtRadioComponent(tabIndex, ngControl) {
            this.ngControl = ngControl;
            this.id = "nt-radio-" + uniqueId++;
            this._disabled = false;
            this._readonly = false;
            this._checked = false;
            this._name = this.id;
            this.change = new core.EventEmitter();
            this._onChange = function () { };
            this._onTouched = function () { };
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
            this.tabIndex = parseInt(tabIndex) || 0;
        }
        Object.defineProperty(NtRadioComponent.prototype, "value", {
            get: function () { return this._value; },
            set: function (value) { this._value = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioComponent.prototype, "disabled", {
            get: function () { return this._disabled; },
            set: function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioComponent.prototype, "readonly", {
            get: function () { return this._readonly; },
            set: function (value) { this._readonly = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioComponent.prototype, "checked", {
            get: function () { return this._checked; },
            set: function (value) { this._checked = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioComponent.prototype, "name", {
            get: function () { return this._name; },
            set: function (value) { this._name = value; },
            enumerable: false,
            configurable: true
        });
        NtRadioComponent.prototype.writeValue = function (value) {
            this._checked = !!value;
        };
        NtRadioComponent.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NtRadioComponent.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        NtRadioComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        NtRadioComponent.prototype._onInputClick = function (event) {
            event.stopPropagation();
        };
        NtRadioComponent.prototype._onInputChange = function (event) {
            event.stopPropagation();
            this._checked = true;
            this._emitChangeEvent();
        };
        NtRadioComponent.prototype._emitChangeEvent = function () {
            var event = new NtRadioChange(this, this.checked);
            this._onChange(this.checked);
            this._onTouched();
            this.change.emit(event);
        };
        return NtRadioComponent;
    }());
    NtRadioComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-radio',
                    encapsulation: core.ViewEncapsulation.None,
                    template: "<label class=\"nt-radio-layout\">\n  <div class=\"nt-radio-input-container\">\n    <input class=\"cdk-visually-hidden\"\n      type=\"radio\"\n      [name]=\"name\"\n      [tabIndex]=\"tabIndex\"\n      [disabled]=\"disabled\"\n      [checked]=\"checked\"\n      (change)=\"_onInputChange($event)\"\n      (click)=\"_onInputClick($event)\">\n    <div class=\"nt-radio-input\"></div>\n  </div>\n  <span class=\"nt-radio-label\">\n    <ng-content></ng-content>\n  </span>\n</label>\n",
                    host: {
                        'class': 'nt-radio',
                        '[class.nt-radio-disabled]': 'disabled'
                    }
                },] }
    ];
    NtRadioComponent.ctorParameters = function () { return [
        { type: String, decorators: [{ type: core.Attribute, args: ['tabindex',] }] },
        { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional }] }
    ]; };
    NtRadioComponent.propDecorators = {
        value: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        readonly: [{ type: core.Input }],
        checked: [{ type: core.Input }],
        name: [{ type: core.Input }],
        change: [{ type: core.Output }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    function getNtRdioGroupNonFunctionValueError() {
        return Error('`compareWith` must be a function.');
    }
    var uniqueId$1 = 0;
    var NtRadioGroupComponent = /** @class */ (function (_super) {
        __extends(NtRadioGroupComponent, _super);
        function NtRadioGroupComponent(_ngZone, _changeDetectorRef, ngControl) {
            var _this = _super.call(this) || this;
            _this._ngZone = _ngZone;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.ngControl = ngControl;
            _this.id = "nt-radio-group-" + uniqueId$1++;
            _this._destroy = new rxjs.Subject();
            _this._disabled = false;
            _this._readonly = false;
            _this._required = false;
            _this._name = _this.id;
            _this._compareWith = function (o1, o2) { return o1 === o2; };
            _this.checkedChanges = rxjs.defer(function () {
                if (_this.radios) {
                    return rxjs.merge.apply(void 0, __spread(_this.radios.map(function (item) { return item.change; })));
                }
                return _this._ngZone.onStable
                    .asObservable()
                    .pipe(operators.take(1), operators.switchMap(function () { return _this.checkedChanges; }));
            });
            _this._onChange = function () { };
            _this._onTouched = function () { };
            if (_this.ngControl) {
                _this.ngControl.valueAccessor = _this;
            }
            return _this;
        }
        Object.defineProperty(NtRadioGroupComponent.prototype, "value", {
            get: function () { return this._value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioGroupComponent.prototype, "disabled", {
            get: function () { return this._disabled; },
            set: function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioGroupComponent.prototype, "required", {
            get: function () { return this._required; },
            set: function (value) { this._required = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioGroupComponent.prototype, "readonly", {
            get: function () { return this._readonly; },
            set: function (value) { this._readonly = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioGroupComponent.prototype, "name", {
            get: function () { return this._name; },
            set: function (value) {
                this._name = value;
                this._updateRadioButtonNames();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtRadioGroupComponent.prototype, "compareWith", {
            set: function (fn) {
                if (typeof fn !== 'function') {
                    throw getNtRdioGroupNonFunctionValueError();
                }
                else {
                    this._compareWith = fn;
                }
            },
            enumerable: false,
            configurable: true
        });
        NtRadioGroupComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.radios.changes.pipe(operators.startWith(null), operators.takeUntil(this._destroy)).subscribe(function () {
                _this._resetRadios();
                _this._initializeChecked();
            });
        };
        NtRadioGroupComponent.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
        };
        NtRadioGroupComponent.prototype.writeValue = function (value) {
            if (this.radios) {
                this._setCheckedByValue(value);
            }
        };
        NtRadioGroupComponent.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NtRadioGroupComponent.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        NtRadioGroupComponent.prototype.focus = function () {
            if (!this.disabled) {
                this._onTouched();
            }
        };
        NtRadioGroupComponent.prototype._initializeChecked = function () {
            var _this = this;
            Promise.resolve().then(function () {
                _this._updateRadioButtonNames();
                _this._setCheckedByValue(_this.ngControl ? _this.ngControl.value : _this.value);
            });
        };
        NtRadioGroupComponent.prototype._resetRadios = function () {
            var _this = this;
            var changedOrDestroyed = rxjs.merge(this.radios.changes, this._destroy);
            this.checkedChanges.pipe(operators.takeUntil(changedOrDestroyed)).subscribe(function (change) {
                _this._setValues(change.source);
            });
            rxjs.merge.apply(void 0, __spread(this.radios.map(function (item) { return item.change; }))).pipe(operators.takeUntil(changedOrDestroyed))
                .subscribe(function () {
                _this._changeDetectorRef.markForCheck();
            });
        };
        NtRadioGroupComponent.prototype._setCheckedByValue = function (value) {
            this._value = value;
            this.radios.forEach(function (item) { return item.checked = false; });
            this._checkedValue(value);
            this._changeDetectorRef.markForCheck();
        };
        NtRadioGroupComponent.prototype._checkedValue = function (value) {
            var _this = this;
            var correspondingItem = this.radios.find(function (item) {
                try {
                    return item.value != null && _this._compareWith(item.value, value);
                }
                catch (error) {
                    if (core.isDevMode()) {
                        console.warn(error);
                    }
                    return false;
                }
            });
            if (correspondingItem) {
                correspondingItem.checked = true;
            }
            return correspondingItem;
        };
        NtRadioGroupComponent.prototype._setValues = function (radio) {
            this._value = radio.value;
            this._onChange(this._value);
            this._onTouched();
            this._changeDetectorRef.markForCheck();
        };
        NtRadioGroupComponent.prototype._updateRadioButtonNames = function () {
            var _this = this;
            if (this.radios) {
                this.radios.forEach(function (radio) {
                    radio.name = _this.name;
                });
            }
        };
        return NtRadioGroupComponent;
    }(forms$1.NtFormFieldControl));
    NtRadioGroupComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-radio-group',
                    template: '<ng-content></ng-content>',
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: forms$1.NtFormFieldControl, useExisting: NtRadioGroupComponent }
                    ],
                    host: {
                        'class': 'nt-radio-group'
                    }
                },] }
    ];
    NtRadioGroupComponent.ctorParameters = function () { return [
        { type: core.NgZone },
        { type: core.ChangeDetectorRef },
        { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional }] }
    ]; };
    NtRadioGroupComponent.propDecorators = {
        disabled: [{ type: core.Input }],
        required: [{ type: core.Input }],
        readonly: [{ type: core.Input }],
        name: [{ type: core.Input }],
        radios: [{ type: core.ContentChildren, args: [NtRadioComponent,] }],
        compareWith: [{ type: core.Input }],
        checkedChanges: [{ type: core.Output }]
    };

    var NtRadioModule = /** @class */ (function () {
        function NtRadioModule() {
        }
        return NtRadioModule;
    }());
    NtRadioModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [NtRadioComponent, NtRadioGroupComponent],
                    declarations: [NtRadioComponent, NtRadioGroupComponent],
                },] }
    ];

    exports.NtRadioChange = NtRadioChange;
    exports.NtRadioComponent = NtRadioComponent;
    exports.NtRadioGroupComponent = NtRadioGroupComponent;
    exports.NtRadioModule = NtRadioModule;
    exports.getNtRdioGroupNonFunctionValueError = getNtRdioGroupNonFunctionValueError;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=radio.umd.js.map
