(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/switch', ['exports', '@angular/cdk/coercion', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.switch = {}), global.ng.cdk.coercion, global.ng.core, global.ng.forms, global.ng.common));
}(this, (function (exports, coercion, core, forms, common) { 'use strict';

    var uniqueId = 0;
    var NtSwitchChange = /** @class */ (function () {
        function NtSwitchChange(source, checked) {
            this.source = source;
            this.checked = checked;
        }
        return NtSwitchChange;
    }());
    var NtSwitchComponent = /** @class */ (function () {
        function NtSwitchComponent(_changeDetectorRef, tabIndex, ngControl) {
            this._changeDetectorRef = _changeDetectorRef;
            this.ngControl = ngControl;
            this.id = "nt-switch-" + uniqueId++;
            this._disabled = false;
            this._checked = false;
            this._circle = false;
            this.change = new core.EventEmitter();
            this._onChange = function () { };
            this._onTouched = function () { };
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
            this.tabIndex = parseInt(tabIndex) || 0;
        }
        Object.defineProperty(NtSwitchComponent.prototype, "disabled", {
            get: function () { return this._disabled; },
            set: function (value) {
                if (value !== this.disabled) {
                    this._disabled = coercion.coerceBooleanProperty(value);
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtSwitchComponent.prototype, "checked", {
            get: function () { return this._checked; },
            set: function (value) {
                if (value !== this.checked) {
                    this._checked = coercion.coerceBooleanProperty(value);
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtSwitchComponent.prototype, "circle", {
            get: function () { return this._circle; },
            set: function (value) {
                if (value !== this.circle) {
                    this._circle = coercion.coerceBooleanProperty(value);
                }
            },
            enumerable: false,
            configurable: true
        });
        NtSwitchComponent.prototype.writeValue = function (value) {
            this._checked = !!value;
        };
        NtSwitchComponent.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NtSwitchComponent.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        NtSwitchComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        NtSwitchComponent.prototype._onInputClick = function (event) {
            event.stopPropagation();
            if (!this.disabled) {
                this._checked = !this._checked;
                this._onTouched();
                this._emitChangeEvent();
            }
        };
        NtSwitchComponent.prototype._onInteractionEvent = function (event) {
            event.stopPropagation();
        };
        NtSwitchComponent.prototype._emitChangeEvent = function () {
            var event = new NtSwitchChange(this, this.checked);
            this._onChange(this.checked);
            this.change.emit(event);
        };
        return NtSwitchComponent;
    }());
    NtSwitchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-switch',
                    template: "<input class=\"switch-input\" type=\"checkbox\"\n  [attr.id]=\"id\"\n  [tabIndex]=\"tabIndex\"\n  [checked]=\"checked\"\n  [disabled]=\"disabled\"\n  (change)=\"_onInteractionEvent($event)\"\n  (click)=\"_onInputClick($event)\">\n<label class=\"switch-paddle\" [attr.for]=\"id\"></label>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'switch nt-switch',
                        '[class.nt-switch-checked]': 'checked',
                        '[class.nt-switch-disabled]': 'disabled',
                        '[class.nt-switch-circle]': 'circle'
                    },
                    providers: [
                        { provide: forms.NG_VALUE_ACCESSOR, useExisting: NtSwitchComponent, multi: true }
                    ]
                },] }
    ];
    NtSwitchComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: String, decorators: [{ type: core.Attribute, args: ['tabindex',] }] },
        { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional }] }
    ]; };
    NtSwitchComponent.propDecorators = {
        disabled: [{ type: core.Input }],
        checked: [{ type: core.Input }],
        circle: [{ type: core.Input }],
        change: [{ type: core.Output }]
    };

    var NtSwitchModule = /** @class */ (function () {
        function NtSwitchModule() {
        }
        return NtSwitchModule;
    }());
    NtSwitchModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [NtSwitchComponent],
                    declarations: [NtSwitchComponent]
                },] }
    ];

    exports.NtSwitchChange = NtSwitchChange;
    exports.NtSwitchComponent = NtSwitchComponent;
    exports.NtSwitchModule = NtSwitchModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=switch.umd.js.map
