(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/overlay'), require('@angular/cdk/overlay')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/tooltip', ['exports', '@angular/common', '@angular/core', '@ng-tangram/components/overlay', '@angular/cdk/overlay'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.tooltip = {}), global.ng.common, global.ng.core, global.nt.components.overlay, global.ng.cdk.overlay));
}(this, (function (exports, common, core, overlay, overlay$1) { 'use strict';

    var NtTooltipComponent = /** @class */ (function () {
        function NtTooltipComponent(_elementRef) {
            this._elementRef = _elementRef;
            this._title = '';
            this.position = overlay.NtOverlayPosition.Top;
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay$1.CdkOverlayOrigin(_elementRef);
        }
        Object.defineProperty(NtTooltipComponent.prototype, "title", {
            get: function () { return this._title; },
            set: function (value) { this._title = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtTooltipComponent.prototype, "template", {
            get: function () { return this._template; },
            set: function (value) { this._template = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtTooltipComponent.prototype, "tooltip", {
            set: function (value) {
                if (value instanceof core.TemplateRef) {
                    this._template = value;
                }
                else {
                    this._title = value;
                    this._template = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtTooltipComponent.prototype, "_isDirective", {
            get: function () {
                var attributes = this._elementRef.nativeElement.attributes;
                return attributes && attributes['nt-tooltip'];
            },
            enumerable: false,
            configurable: true
        });
        NtTooltipComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            var change = changes.title || changes.template || changes.tooltip;
            if (change && !change.firstChange) {
                Promise.resolve().then(function () {
                    _this.overlay.forceUpdatePosition();
                });
            }
        };
        NtTooltipComponent.prototype._afterOpen = function (event) {
            this.afterOpen.next(event);
        };
        NtTooltipComponent.prototype._afterClosed = function (event) {
            this.afterClosed.next(event);
        };
        NtTooltipComponent.prototype._beforeOpen = function (event) {
            this.beforeOpen.next(event);
        };
        NtTooltipComponent.prototype._beforeClosed = function (event) {
            this.beforeClosed.next(event);
        };
        NtTooltipComponent.prototype._positionChange = function (change) {
            this.positionChange.next(change);
        };
        return NtTooltipComponent;
    }());
    NtTooltipComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-tooltip, [nt-tooltip]',
                    template: "<ng-content></ng-content>\n<nt-overlay\n  overlayClass=\"nt-tootip-overlay\"\n  arrow\n  [origin]=\"origin\"\n  [position]=\"position\"\n  (afterOpen)=\"_afterOpen($event)\"\n  (afterClosed)=\"_afterClosed($event)\"\n  (beforeOpen)=\"_beforeOpen($event)\"\n  (beforeClosed)=\"_beforeClosed($event)\"\n  (overlayEnter)=\"overlay.markOpen()\"\n  (overlayLeave)=\"overlay.markClose()\"\n  (positionChange)=\"_positionChange($event)\">\n  <div class=\"nt-tooltip-content\" *ngIf=\"template\">\n    <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n  </div>\n  <div class=\"nt-tooltip-content\" *ngIf=\"!template\" [innerHtml]=\"title\"></div>\n</nt-overlay>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        'class': 'nt-tooltip',
                        '[class.nt-tooltip-trigger]': '!_isDirective',
                        '(mouseenter)': 'overlay.markOpen()',
                        '(mouseleave)': 'overlay.markClose()'
                    }
                },] }
    ];
    NtTooltipComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    NtTooltipComponent.propDecorators = {
        title: [{ type: core.Input }],
        template: [{ type: core.Input }],
        tooltip: [{ type: core.Input, args: ['nt-tooltip',] }],
        position: [{ type: core.Input }],
        afterOpen: [{ type: core.Output }],
        afterClosed: [{ type: core.Output }],
        beforeOpen: [{ type: core.Output }],
        beforeClosed: [{ type: core.Output }],
        positionChange: [{ type: core.Output }],
        overlay: [{ type: core.ViewChild, args: [overlay.NtOverlayComponent, { static: true },] }]
    };

    var NtTooltipModule = /** @class */ (function () {
        function NtTooltipModule() {
        }
        return NtTooltipModule;
    }());
    NtTooltipModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, overlay.NtOverlayModule],
                    exports: [NtTooltipComponent],
                    declarations: [NtTooltipComponent]
                },] }
    ];

    exports.NtTooltipComponent = NtTooltipComponent;
    exports.NtTooltipModule = NtTooltipModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=tooltip.umd.js.map
