import { AfterContentInit, ChangeDetectorRef, EventEmitter } from '@angular/core';
import { DateAdapter, NtDateFormats } from '@ng-tangram/components/core';
import { NtDatePickerCell } from './datepicker-models';
export declare class NtDatePickerMonthComponent<D> implements AfterContentInit {
    private _changeDetectorRef;
    private _dateAdapter;
    private _dateFormats;
    _monthLabel: string;
    _weeks: NtDatePickerCell[][];
    _firstWeekOffset: number;
    _selectedDate: number | null;
    _todayDate: number | null;
    _weekdays: {
        long: string;
        narrow: string;
    }[];
    private _activeDate;
    private _selected;
    private _minDate;
    private _maxDate;
    get activeDate(): D;
    set activeDate(value: D);
    get selected(): D | null;
    set selected(value: D | null);
    get minDate(): D | null;
    set minDate(value: D | null);
    get maxDate(): D | null;
    set maxDate(value: D | null);
    dateFilter: (date: D) => boolean;
    readonly selectedChange: EventEmitter<D | null>;
    readonly activeDateChange: EventEmitter<D>;
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>, _dateFormats: NtDateFormats);
    ngAfterContentInit(): void;
    _dateSelected(cell: NtDatePickerCell): void;
    _init(): void;
    private _createWeekCells;
    private _getWeekOffset;
    private _fillBeforeCells;
    private _fillAfterCells;
    private _shouldEnableDate;
    private _getDateInCurrentMonth;
    private _hasSameMonthAndYear;
    private _getValidDateOrNull;
}
