import { CommonModule } from '@angular/common';
import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';

class NtAvatarComponent {
    constructor() {
        this.class = '';
        this.size = '';
        this._shape = 'square';
        this.src = '';
        this.alt = '';
    }
    get shape() { return this._shape; }
    set shape(value) {
        value === 'circle' && (this._shape = value);
    }
}
NtAvatarComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-avatar',
                template: '<img [src]="src" [alt]="alt">',
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["nt-avatar", size, shape, class].join(" ")',
                    '[class.nt-avatar-circle]': 'shape == "circle"',
                }
            },] }
];
NtAvatarComponent.propDecorators = {
    class: [{ type: Input }],
    size: [{ type: Input }],
    shape: [{ type: Input }],
    src: [{ type: Input }],
    alt: [{ type: Input }]
};

class NtAvatarModule {
}
NtAvatarModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [NtAvatarComponent],
                exports: [NtAvatarComponent]
            },] }
];

export { NtAvatarComponent, NtAvatarModule };
//# sourceMappingURL=avatar.js.map
