import { CommonModule } from '@angular/common';
import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';

class NtButtonGroupComponent {
    constructor() {
        this._expanded = false;
        this.class = '';
        this.color = '';
        this.size = '';
    }
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    get expanded() { return this._expanded; }
}
NtButtonGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-button-group, [nt-button-group]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["button-group", color, size, class].join(" ")',
                    '[class.expanded]': 'expanded'
                }
            },] }
];
NtButtonGroupComponent.propDecorators = {
    class: [{ type: Input }],
    color: [{ type: Input }],
    size: [{ type: Input }],
    expanded: [{ type: Input }]
};

class NtButtonComponent {
    constructor() {
        this._style = '';
        this._expanded = false;
        this.class = '';
        this.color = '';
        this.size = '';
    }
    set button(value) {
        if (this._validStyle(value)) {
            this._style = value;
        }
    }
    set style(value) { this._style = value; }
    get style() { return this._style; }
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    get expanded() { return this._expanded; }
    _validStyle(value) {
        return ['', 'hollow', 'clear'].indexOf(value) > -1;
    }
}
NtButtonComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-button]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["button", color, style, size, class].join(" ")',
                    '[class.expanded]': 'expanded'
                }
            },] }
];
NtButtonComponent.propDecorators = {
    class: [{ type: Input }],
    color: [{ type: Input }],
    size: [{ type: Input }],
    button: [{ type: Input, args: ['nt-button',] }],
    style: [{ type: Input }],
    expanded: [{ type: Input }]
};

class NtButtonModule {
}
NtButtonModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtButtonComponent, NtButtonGroupComponent],
                declarations: [NtButtonComponent, NtButtonGroupComponent],
            },] }
];

export { NtButtonComponent, NtButtonGroupComponent, NtButtonModule };
//# sourceMappingURL=button.js.map
