import { CommonModule } from '@angular/common';
import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';

class NtLabelComponent {
    constructor() {
        this.color = '';
        this.class = '';
    }
}
NtLabelComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-label, [nt-label]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["label", color, class].join(" ")'
                }
            },] }
];
NtLabelComponent.propDecorators = {
    color: [{ type: Input }],
    class: [{ type: Input }]
};

class NtLabelModule {
}
NtLabelModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [NtLabelComponent],
                exports: [NtLabelComponent]
            },] }
];

export { NtLabelComponent, NtLabelModule };
//# sourceMappingURL=label.js.map
