import { CommonModule } from '@angular/common';
import { Component, ViewEncapsulation, Input, ContentChildren, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';

class NtMenuComponent {
    constructor() {
        this._simple = false;
        this._expanded = false;
        this._nested = false;
        this._align = '';
        this.class = '';
        this.orientation = '';
    }
    set simple(value) { this._simple = coerceBooleanProperty(value); }
    get simple() { return this._simple; }
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    get expanded() { return this._expanded; }
    set nested(value) { this._nested = coerceBooleanProperty(value); }
    get nested() { return this._nested; }
    set align(value) { this._align = value; }
    get align() { return this._align; }
    ngAfterContentInit() {
        this.childMenus.toArray()
            .filter(menu => menu !== this)
            .forEach(menu => menu.nested = true);
    }
}
NtMenuComponent.decorators = [
    { type: Component, args: [{
                selector: 'ul[nt-menu], ol[nt-menu]',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["menu", align ? "align-" + align : "", orientation, class].join(" ")',
                    '[class.simple]': 'simple',
                    '[class.expanded]': 'expanded',
                    '[class.nested]': 'nested'
                }
            },] }
];
NtMenuComponent.ctorParameters = () => [];
NtMenuComponent.propDecorators = {
    class: [{ type: Input }],
    simple: [{ type: Input }],
    expanded: [{ type: Input }],
    align: [{ type: Input }],
    orientation: [{ type: Input }],
    childMenus: [{ type: ContentChildren, args: [NtMenuComponent,] }]
};

class NtMenuModule {
}
NtMenuModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtMenuComponent],
                declarations: [NtMenuComponent]
            },] }
];

export { NtMenuComponent, NtMenuModule };
//# sourceMappingURL=menu.js.map
