import { HttpClient } from '@angular/common/http';
import { Injectable, NgModule } from '@angular/core';
import { NtUploadHandler } from '@ng-tangram/components/core';

class NtNoopUploadHandler extends NtUploadHandler {
    constructor(http) {
        super(http);
    }
    getRequestData(file) { return file; }
    getResponseData(body) { return body; }
    getErrorMessage(error) { return error.statusText; }
}
NtNoopUploadHandler.decorators = [
    { type: Injectable }
];
NtNoopUploadHandler.ctorParameters = () => [
    { type: HttpClient }
];

class NtNoopUploadModule {
}
NtNoopUploadModule.decorators = [
    { type: NgModule, args: [{
                providers: [
                    { provide: NtUploadHandler, useClass: NtNoopUploadHandler }
                ]
            },] }
];

export { NtNoopUploadHandler, NtNoopUploadModule };
//# sourceMappingURL=noopupload.js.map
