import { AnimationEvent } from '@angular/animations';
import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { Location } from '@angular/common';
import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { NtOverlayPosition } from './overlay-positions';
export declare class NtOverlayComponent implements AfterViewInit, OnChanges, OnDestroy {
    private _changeDetectorRef;
    private readonly _destroy;
    private _debounceClose;
    private _positionChange;
    private _locationChanges;
    private _outsideClickSubscription;
    private _opened;
    get opened(): boolean;
    private _markClosed;
    private _origin;
    set origin(value: CdkOverlayOrigin);
    get origin(): CdkOverlayOrigin;
    private _position;
    set position(value: NtOverlayPosition);
    private _positionPairs;
    get positionPairs(): ConnectionPositionPair[];
    set positionPairs(value: ConnectionPositionPair[]);
    private _paddingClass;
    get paddingClass(): string;
    private _fixed;
    get fixed(): boolean;
    set fixed(value: boolean);
    private _arrow;
    get arrow(): boolean;
    set arrow(value: boolean);
    private _nospacing;
    get nospacing(): boolean;
    set nospacing(value: boolean);
    private _overlayClass;
    get overlayClass(): string;
    set overlayClass(value: string);
    private _backdrop;
    get backdrop(): boolean;
    set backdrop(value: boolean);
    cdkConnectedOverlay: CdkConnectedOverlay;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    overlayEnter: EventEmitter<any>;
    overlayLeave: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    keydownEvents: EventEmitter<KeyboardEvent>;
    constructor(_changeDetectorRef: ChangeDetectorRef, location: Location);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    open(): void;
    close(): void;
    toggle(): void;
    markOpen(): void;
    markClose(): void;
    forceUpdatePosition(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    onOverlayPositionChange(event: ConnectedOverlayPositionChange): void;
    private _setPosition;
    private _subscribeOutsideClickEvent;
    private _unsubscribeOutsideClickEvent;
}
